/**
 * Created by robin on 12/11/16.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luWebApiDataAccess', ['luDataAccess', 'luRequest', function (luDataAccess, luRequest) {

            var luWebApiDataAccess = {};

            luWebApiDataAccess.create = function (entry_point) {
                var DataAccess = luDataAccess.create();

                DataAccess.entry_point = entry_point;
                if (DataAccess.entry_point.substr(-1) !== '/') {
                    DataAccess.entry_point += '/';
                }

                DataAccess.get = function(url, dataGet, luBusyGroups)
                {
                    return luRequest.get(DataAccess.entry_point + url, dataGet, luBusyGroups);
                };

                DataAccess.post = function(url, dataGet, dataPost, luBusyGroups)
                {
                    return luRequest.post(DataAccess.entry_point + url, dataGet, dataPost, luBusyGroups);
                };

                DataAccess.put = function(url, dataGet, dataPost, luBusyGroups)
                {
                    return luRequest.put(DataAccess.entry_point + url, dataGet, dataPost, luBusyGroups);
                };

                DataAccess.delete = function(url, dataGet, dataPost, luBusyGroups)
                {
                    return luRequest.delete(DataAccess.entry_point + url, dataGet, dataPost, luBusyGroups);
                };

                return DataAccess;
            };

            return luWebApiDataAccess;

        }]);
})();